package it.polito.bigdata.hadoop.exercise1;

import java.io.IOException;

import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

/**
 * Exercise 1 - Mapper
 */
class MapperBigData extends
		Mapper<LongWritable, // Input key type
				Text, // Input value type
				NullWritable, // Output key type
				Text> {// Output value type

	protected void map(LongWritable key, // Input key type
			Text value, // Input value type
			Context context) throws IOException, InterruptedException {

		// Split value
		// stockId,date,hour:minute,price
		// Example: GOOG,2015/05/21,15:05,45.32
		String[] fields = value.toString().split(",");

		String stockId = fields[0];
		String date = fields[1];
		String hourAndMinute = fields[2];
		String price = fields[3];

		// Select only stockId GOOG and year 2017
		if (date.startsWith("2017") == true && stockId.equals("GOOG")) {
			// emit pair (null, date+","+hourAndMinutes+","+price)
			context.write(NullWritable.get(), new Text(date + "," + hourAndMinute + "," + price));
		}
	}
}
